
    //************************************//
    //************************************//
           //   ()    
    //************************************//
    //************************************// 
        #include <avr/io.h>  
        #include <avr/pgmspace.h> 
        #include <avr/interrupt.h>  
        #include <avr/eeprom.h>
                                     // 0   1  2  3    4   5   6   7  8   9     -  C   F
        unsigned char Sifra[]PROGMEM= {235,40,179,186,120,218,219,168,251,250, 0, 16,195,209,\
                                    // -     F   -    -   F   -    -   F    
                                       16, 0, 0, 209, 16,  0, 16, 209, 16, 0, 16, 209,\ 
                                    // -     L   -    -   L   -    -   L  
                                      16,  0,  0, 67, 16, 0,  16, 67,  16,  0, 16,67,\ 
                                    // -     C   -    -   C   -    -   C  
                                      16,  0,  0,195, 16,  0,  16, 195,16,0,  16, 195,
                                   //  E   P
                                      211,17 };
               
        volatile unsigned char   Vrema_Da,Vrema_No,Tok_Da,Tok_No,Temp,Razgon,Razgon_,Vrema_Zbros,Tt;
        volatile unsigned  int   Tok_0,Tok_1,ACP,Vrema_,D,Tok_Perebeg,Tok_Zbros; 
        volatile unsigned  char  DanieKanal_01,DanieKanal_02,DanieKanal_03,Bit_Deistvia,Bit_Deistvia1,Previ;
        volatile unsigned  char  DanieKanal_13,DanieKanal_12,DanieKanal_11,i;

        #define InD_Dan(a,b,c) b=0;while (c > a ){ c=(c-a);b++;}if(c == a ){b++;c=(c-a);}
        #define Razrad(a,b) if (a==0){ a = 10;if (b ==0)b = 10;} 
       
        #include "Indikator.c"      //  LCD
        #include "Tok.h"
        #include "Nastroika.h"
     //*******************************************//     
     //*******************************************//          
      ISR  (TIMER0_COMP_vect) //  T0
        { 
           Vrema_++;  
           Temp++;
           if (Temp == 60 )
            {
              Razgon_--;
              Previ--;
              Temp = 0;
            } 
                    
           Knopka_();  
           IND();                
        } 
        //==================//
          //   
        //==================//   
      ISR  (ADC_vect)                 //  T0             
         {                                                     
            ACP=ADCW;                 //              
            ADMUX ^=(1<<MUX0);        //  (portA0,portA1) 
            ADCSRA |= (1<<ADSC);      //                                      
            if (ADMUX &(1<<MUX0))     
              {                               
                Preobraz_1(); 
              }
             else
              {
               Preobraz_0();                                                                                                      
              }                                                                                                                         
         }      
     //*******************************************// 
     //*******************************************//      
  main (voit)
         {            
            ystanovkaIndikatora();
            ystanovka_Knopok(); 
            ystanovka_ASP();
            DDRC |= (1<<7);
            PORTC &=~ (1<<7);
            Ystanovka_Dan();
            while(1)
              {            
               Meny_Nastroik();                           //  
         HH:   
                sei();               
                asm("nop");  
                asm("nop"); 
                asm("nop"); 
                cli();
                if(Bit_Deistvia1 & (1<<2))
                  Prover_Avaria();                                                        
                if(Bit_Deistvia & (1<<2)){}               //     (    )
                else 
                 { 
               //**************************//    
                   if(Bit_Deistvia1 & (1<<6))
                    {
                     if (Razgon_ == 0)
                      {
                        if (Bit_Deistvia1 & (1<<5))
                         {
                           Razrad_1=10;    //
                           Razrad_2=10;    //
                           Razrad_3=10;    //
                           Bit_Deistvia1 &=~(1<<5);                 
                           Razgon_=5; 
                         }
                        else
                         {
                           Razrad_1=51;    //
                           Razrad_2=51;    //
                           Razrad_3=50;    //
                           Bit_Deistvia1 |=(1<<5);
                           Razgon_=5;
                         } 
                       }           
                     }               
                    else 
                     {                                                                                                                                              
                   //====================//
                        //  
                   //====================//
                    //if((Tok_1==0)&(Tok_0==0))             //      
                      if(Tt == 3)
                      {
                        if(Bit_Deistvia & (1<<5))         //    
                         {
                            
                           D = 0;                         
                           Vrema_ = 0;  
                           Razrad_1 = 10;                 
                           Razrad_2 = 10;
                           Razrad_3 = 10;
                           Bit_Deistvia &=~(1<<5);        //    
                           Bit_Deistvia &=~(1<<6);        
                           Bit_Deistvia &=~(1<<1);
                           Bit_Deistvia &=~(1<<0);
                           i=0;
                         }
                      }
                     else              
                      {
                        if (Bit_Deistvia & (1<<5)){}      //   
                         else
                          {
                            Razgon_ = Razgon;             //  
                            Bit_Deistvia |=(1<<5);        //                                                                         
                          }
                        if (Bit_Deistvia & (1<<6)) {}     
                         else      
                          {
                            i=Razgon_; 
                            InD_Dan(100,Razrad_3,i);      // 
                            InD_Dan(10,Razrad_2,i);       //   
                            Razrad_1 = i;                 //
                            Razrad(Razrad_3,Razrad_2)     //     
                            if(Razgon_ == 0)              //  
                             {
                               Bit_Deistvia |=(1<<6);
                               Bit_Deistvia &=~(1<<1);
                               Bit_Deistvia &=~(1<<0);
                               D = 0;
                               Vrema_ = 0;  
                               Razrad_1=10;
                               Razrad_2=10;
                               Razrad_3=10;
                               i=0;
                             }        
                            goto HH;
                          } 
                      } 
                    sei();               
                    asm("nop");  
                    asm("nop"); 
                    asm("nop"); 
                    cli();                                              
                    //=========================//
                        //   //
                    //=========================//
                    Tok_Slet();                                                         
                   //====================//
                     //   
                   //====================//                  
                    if (Bit_Deistvia &(1<<1))              //    2 
                      {                                                                                                                                                                                                                                                                                                                                                                  
                        InD_Dan(100,DanieKanal_03,Tok_1);  // 
                        InD_Dan(10,DanieKanal_02,Tok_1);   //             
                        DanieKanal_01=Tok_1;               //                                            
                        Bit_Deistvia^=(1<<1);              //  
                        if(DanieKanal_03 == 0 )            //     
                          DanieKanal_03=10;                                                                                           
                      }
                    sei();
                    asm("nop");
                    asm("nop");
                    cli(); 
                  //======================//
                    //  
                  //======================//
                    if (Bit_Deistvia &(1<<0))             //    1 
                     {                                                                                                                                                                                                                                                                                                                                                                     
                       InD_Dan(100,DanieKanal_13,Tok_0);  // 
                       InD_Dan(10,DanieKanal_12,Tok_0);   //             
                       DanieKanal_11=Tok_0;               //
                       Bit_Deistvia^=(1<<0);              //                                                                          
                       if(DanieKanal_13 == 0 )            //    
                          DanieKanal_13=10;                
                     }
                    sei();
                    asm("nop");
                    asm("nop");
                    cli();                                                          
                    Nadpis();                                                                      
                 } 
               }                                              
             }             
          } 
           //****************************//
           //****************************// 
               //      (-1- ,-2-)
           //****************************// 
           //****************************//        
       #define Mig_( a, d, f) if (i<a){if(i==(a-2)){f=10;return;}if(i==(a-1))f=d;else f=10;return;}                                                                                                                                                          
       Nadpis ( )
        {             
          if (Vrema_>D)
            {               
              Vrema_=0;
              i++; 
              D = (i==6) ? 500:(i==12)? 800:(i==18)? 500:(i==24)? 800:30;
              Mig_(3,11,Razrad_1);
              Mig_(5,1,Razrad_2);             
              Mig_(7,11,Razrad_3); 
            
              Mig_(9, DanieKanal_11,Razrad_1);
              if(i<14)
                Razrad_2 |=(1<<7);
              Mig_(11,DanieKanal_12,Razrad_2);             
              Mig_(13,DanieKanal_13,Razrad_3); 

              Mig_(15,11,Razrad_1);
              Mig_(17,2,Razrad_2);
              Mig_(19,11,Razrad_3);

              Mig_(21,DanieKanal_01,Razrad_1);
              if(i<24)
                Razrad_2 |=(1<<7);
              Mig_(23,DanieKanal_02,Razrad_2);              
              Mig_(24,DanieKanal_03,Razrad_3);

              i=0;               
            }               
        }
          //*******************************//
          //*******************************//
              //   EEPROMA             
          //*******************************//
          //*******************************//
      Ystanovka_Dan()
       {        
         Razgon_=5;         
         Bit_Deistvia1=0;
         Razrad_1 = eeprom_read_word(0x010);      //  eeproma 
         Razrad_2 = eeprom_read_word(0x011);      //  eeproma 
         Razgon = (Razrad_2 * 10) + Razrad_1;     // 
         if(Razgon>159)
          {
            Bit_Deistvia1 |=(1<<7);
            Bit_Deistvia1 |=(1<<6); 
            Razrad_1=10;    //
            Razrad_2=10;    //
            Razrad_3=10;    //       
            return;
          }
         Razrad_1 = eeprom_read_word(0x013);      //  eeproma 
         Razrad_2 = eeprom_read_word(0x014);      //  eeproma 
         Tok_Zbros = (Razrad_2 * 10) + Razrad_1;  //  
         if((Tok_Zbros > 39) | (Tok_Zbros == 0))
          {
            Bit_Deistvia1 |=(1<<7);
            Bit_Deistvia1 |=(1<<6);
            Razrad_1=10;    //
            Razrad_2=10;    //
            Razrad_3=10;    //
            return;
          } 
         Tok_Perebeg = (Tok_Zbros * 10) + Tok_Zbros;     
         Razrad_1 = eeprom_read_word(0x016);      //  eeproma   
         Razrad_2 = eeprom_read_word(0x017);      //  eeproma   
         Vrema_Zbros = (Razrad_2 * 10) + Razrad_1;//  . 
         if(Vrema_Zbros > 100)
          {
            Bit_Deistvia1 |=(1<<7);
            Bit_Deistvia1 |=(1<<6);  
            Razrad_1=10;    //
            Razrad_2=10;    //
            Razrad_3=10;    //
            return;       
          }         
         Razrad_1 = eeprom_read_word(0x20);      //  eeproma   
         if(Razrad_1 != 0)
          {
            Bit_Deistvia1 |=(1<<2);
            return;
          }
         PORTC |=(1<<7);   
       }                           
                    //*****************************//
                    //*****************************//
                           //   //
                    //*****************************//
                    //*****************************//
                Tok_Slet()
                  {
                    if (Bit_Deistvia &(1<<1))              //    2 
                     {
                       if((Tok_Zbros * 10) < Tok_1)               //  
                        {
                          if(Tok_Perebeg < Tok_1)          //  10%   
                           {
                             Bit_Deistvia1 |=(1<<2);       // 
                             eeprom_write_word(0x20,10);   //  eeprom 
                           }
                           else
                           {
                             Bit_Deistvia1 |=(1<<0);       //  
                           }                                                 
                        }
                       else
                        {
                          Bit_Deistvia1 &=~(1<<0);         //  
                        }                         
                     }                                       
                     //=====================//
                     //=====================//
                    if (Bit_Deistvia &(1<<0))              //    1 
                     {
                       if((Tok_Zbros * 10) < Tok_0)               //  
                        {
                          if(Tok_Perebeg < Tok_0)          //  10%   
                           {
                             Bit_Deistvia1 |=(1<<2);       // 
                             eeprom_write_word(0x20,10);     //  eeprom 
                           }
                           else
                           {
                             Bit_Deistvia1 |=(1<<1);       //  
                           }                                                 
                        }
                       else
                        {
                          Bit_Deistvia1 &=~(1<<1);         //  
                        }                         
                     }                   
                 //=======================//
                    if((Bit_Deistvia1 |(1<<0))&(Bit_Deistvia1 |(1<<1)))    
                     {
                       if(Previ  == 0)
                        {
                           Bit_Deistvia1 |=(1<<2);         //   
                           eeprom_write_word(0x20,10);     //  eeprom 
                        }
                     }
                    else
                     {
                       Temp = 0;
                       Previ= Vrema_Zbros;
                     }      
                  }
        //************************************************//
        //************************************************//
            Prover_Avaria() 
             {                                
                PORTC &=~(1<<7); 
                D = 1;
                i = 0;
                Bit_Deistvia1 = 0;
                Bit_Deistvia = 0;
                Razgon_ = 5;             
                Temp  = 0;
                Razrad_1=10;    //
                Razrad_2=10;    //
                Razrad_3=10;    //
                while(D==1)
                 {
                   sei();               
                   asm("nop");  
                   asm("nop"); 
                   asm("nop"); 
                   cli();
                   if (Razgon_ == 0)
                    {
                      if (Bit_Deistvia1 & (1<<5))
                       {
                         Razrad_1=10;    //
                         Razrad_2=10;    //
                         Razrad_3=10;    //
                         Bit_Deistvia1 &=~(1<<5);                 
                         Razgon_=5; 
                       }
                      else
                       {
                         Razrad_1=11;    //
                         Razrad_2=11;    //
                         Razrad_3=11;    //
                         Bit_Deistvia1 |=(1<<5);
                         Razgon_=5;
                       } 
                    }           
                   if((Vrema_Da==10)&(Tok_Da==10))    //     
                    {   
                      Bit_Deistvia1 |=(1<<2);                      
                      Razrad_1=10;    //
                      Razrad_2=10;    //
                      Razrad_3=10;    //                      
                    }
                   if(Bit_Deistvia1 &(1<<2))
                    {
                      if((Vrema_No==10)&(Tok_No==10))    //     
                      {
                        eeprom_write_word(0x20,0);     //  eeprom 
                        Bit_Deistvia1 = 0;
                        Razgon_=0;
                        D=0;
                      }
                      
                    }
                  asm("nop");
                 } 
                PORTC |=(1<<7);   
             }

     




 
 
 
 
 
 
 
 
 
 
 
 
 
 
     
